package com.myorg.springaop.examples;

import org.acegisecurity.context.SecurityContextHolder;
import org.acegisecurity.userdetails.UserDetails;
import org.aspectj.lang.ProceedingJoinPoint;


public class MySecurityAspect
{
    public Object checkSecurity(ProceedingJoinPoint call) throws Throwable
    {
        System.out.println("from security aspect: checking method call for " + call.toShortString());
        Object obj = SecurityContextHolder.getContext().getAuthentication().getPrincipal();

        String username = "";
        if (obj instanceof UserDetails) 
          username = ((UserDetails)obj).getUsername();
        else 
          username = obj.toString();

        //do authorization check here
        
        System.out.println("from security aspect: authenticated user is "+username);
        return call.proceed();
    }

}
