package com.myorg.springaop.examples;

import org.acegisecurity.Authentication;
import org.acegisecurity.AuthenticationManager;
import org.acegisecurity.context.SecurityContextHolder;
import org.acegisecurity.providers.UsernamePasswordAuthenticationToken;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.myorg.soa.services.entity.spring.test.EntityServiceSpringTest;


public class MyTest
{
    public static ApplicationContext context 
        = new ClassPathXmlApplicationContext(new String[] {"my-spring-config.xml"});
    
    public static void main(String[] args)
    {
        login("ganesh","password");
        
        System.out.println(((MyService)context.getBean("MyService")).doSomething("hi and hello to all"));
    }

    //this initializes the ACEGI security framework, and also does user authentication
    //user authorization is done in the security aspect POJO
    public static void login(String username, String password)
    {
        AuthenticationManager authenticationManager 
        = (AuthenticationManager)EntityServiceSpringTest.context.getBean("authenticationManager");

        UsernamePasswordAuthenticationToken request 
            = new UsernamePasswordAuthenticationToken(username, password);
        
        Authentication result = authenticationManager.authenticate(request);
        SecurityContextHolder.getContext().setAuthentication(result);
        
        System.out.println("the authentication result is :"+result);
        
    }
    
}
